// Ex0501
// Ex0604; Dec. 01,2018 by A.T.
// Nov. 11, 2019 by H.K.
//

#include "myVelocity.h"
#include "myFastLed.h"
#include "myDist.h"

void setup() {
  mySetup();        // velocityJJ7(motor)の初期設定
  myFastLedSetup(); // ringLEDの初期設定
  JJ7Axes();        // JJ7の座標表示（車軸・中心線）
  myDistSetup();    // 距離計の
  
  while (digitalRead(SW_PIN)==HIGH);
  delay(200);  // スイッチが押されるとスケッチが動き出す
}

void loop() {
  int y = dist_measure00(50, 500);
  if (y != -1) {// 50[mm]から500[mm]までの距離測定
    Serial.println(y);
    int s = robot_state(y); // ロボットの状態を調べて
    robot_act(s);           // ロボットに適切な速度を与える
    delay(10);
  }
}

// 制御関係
const float KP = 10.0; // 比例定数:20,30,40と変える
float d = 100; // 目標距離 100[mm]
int u; // 制御量
const int sp=300;

int robot_state(float y) {
  int s;

  u = KP * (d - y);   // 比例制御
  if (u > sp) u = sp;  // 設定速度を超過
  if (u < -sp) u = -sp;// 設定速度を超過
  Serial.println(u);
  if (u == 0) {
    s = 0; // 停止
  }
  else if (u > 0) {
    s = 1; // 後退
  }
  else if (u < 0) {
    s = 2; // 前進
  }
  return s;
}

void robot_act(int s) {
  switch (s) {
    case 0: // 停止
      velocityJJ7(0.0, 0.0);
//      motor(0, 0, HIGH, HIGH);
      break;
    case 1: // 後退
      velocityJJ7(0.0, -u);
//      motor((int)u, (int)u, LOW, LOW);
      break;
    case 2: // 前進
      velocityJJ7(0.0, -u);
//      motor((int) -u, (int) -u, HIGH, HIGH);
      break;
    default: // 停止
      velocityJJ7(0.0, 0.0);
//      motor(0, 0, HIGH, HIGH);
      break;
  }
}
