// Ex0502
// Ex401&Ex0604 : Dec. 01, 2018 by A.T.
// Nov. 1, 2019 by H.K.
//

#include "myVelocity.h"
#include "myFastLed.h"
#include "myDist.h"

void setup() {
  mySetup();
  myFastLedSetup();
  JJ7Axes();
  myDistSetup();
  
  while (digitalRead(SW_PIN)==HIGH);
  delay(100);
}

void loop() {
  int y = dist_measure00(50, 500);// 50[mm]から500[mm]までの距離測定
  if (y != -1) {
    Serial.println(y);
    int s = robot_state(y); // ロボットの状態
    robot_act(s); // 状態に合わせロボットてを制御
    delay(10);
  }
}

// 制御関係
const float KP = 10.0; // 比例定数
float d = 100; // 目標距離 100[mm]
int u; // 制御量
const int sp=300;

int robot_state(float y) {
  int s;

  u = KP * (d - y); // 比例制御
  if (u > sp) u = sp;  // 設定速度を超過
  if (u < -sp) u = -sp;// 設定速度を超過
  Serial.println(u);
  if (u == 0) {
    s = 0; // 停止
  }
  else if (u > 0) {
    s = 1; // 後退
  }
  else if (u < 0) {
    s = 2; // 前進
  }
  return s;
}

void robot_act(int s) {
  switch (s) {
    case 0: // 停止
//      velocityJJ7(0.0, 0.0);
//      break;
    case 1: // 後退
    case 2: // 前進
      velocityJJ7(0.0, -u);
      break;
    default: // 停止
      velocityJJ7(0.0, 0.0);
      break;
  }
}
