#include <Wire.h> // 距離センサに必要
#include <VL53L0X.h>  // 距離センサに必要

VL53L0X sensor; // 距離センサ用の定義
unsigned long d_timen = 0, d_timep = 0; // 距離センサ用の計測タイマー変数

void myDistSetup(){
  // シリアル通信の初期化
  Serial.begin(115200);
  delay(100);

  // 距離センサの初期化
  Wire.begin();
  sensor.init(); // センサの初期化
  sensor.setTimeout(500); // タイムアウト 500ms
  sensor.startContinuous(); // 連続計測モード  
}

int dist_measure(unsigned int d_time, unsigned int d_min, unsigned int d_max) {
  d_timen = millis(); // 現在の時間(ms)
  if (d_timen - d_timep > d_time) { // d_time(例えば50ms)経過したら
    d_timep = d_timen; // 前の時間を現在の時間に
    unsigned int d = sensor.readRangeContinuousMillimeters(); // 距離の計測(mm単位)
    if (sensor.timeoutOccurred()) { // タイムアウト発生
      Serial.println(" TIMEOUT");
    }
    if (d > d_min && d < d_max) {
      return d;
    }
  }
  return -1;
}

int dist_measure00(unsigned int d_min, unsigned int d_max) {
  unsigned int d = sensor.readRangeContinuousMillimeters(); // 距離の計測(mm単位)
  if (d > d_min && d < d_max) {
    return (int) d;
  }
  return -1;
}
