// Ex0503
// Nov. 11, 2019 by H.K.
//

#include "myVelocity.h"
#include "myFastLed.h"
#include "myDist.h"

void setup() {
  mySetup();
  myFastLedSetup();
  JJ7Axes();
  myDistSetup();
  
  while (digitalRead(SW_PIN)==HIGH);
  delay(100);
}

void loop() {
  int y = dist_measure00(0, 500);
  if (y != -1) {// 0[mm]から500[mm]までの距離測定
    Serial.println(y);
    robot_state(y); // ロボットの状態
    delay(10);
  }
}

// 制御関係
const float KP = 10.0;
float d = 100; // 目標距離 100[mm]
int u; // 制御量
const int sp=300;

void robot_state(float y) {

  u = KP * (d - y);   // 比例制御
  if (u > sp) u = sp;  // 設定速度を超過
  if (u < -sp) u = -sp;// 設定速度を超過
  Serial.println(u);
  if (u == 0) { //設定した距離にいる
      velocityJJ7(0.0, 0.0);
  }
  else if (u > 0) { //設定した距離を通り過ぎている
      velocityJJ7(0.0, -u);// -u:バックさせる
  }
  else if (u < 0) { //設定した距離に達していない
      velocityJJ7(0.0, -u);// -u:そのまま前進する
  }
}
