// Ex0504
// Nov. 11, 2019 by H.K.
//

#include "myVelocity.h"
#include "myFastLed.h"
#include "myDist.h"

void setup() {
  mySetup();
  myFastLedSetup();
  JJ7Axes();
  myDistSetup();
  
  while (digitalRead(SW_PIN)==HIGH);
  delay(100);
}

void loop() {
  int y = dist_measure00(0, 500);
  if (y != -1) {// 0[mm]から500[mm]までの距離測定
    Serial.println(y);
    JJ7Controller(y); // ロボットを負帰還比例制御
    delay(10);        // 信号により前後に動かせる
  }
}

// 制御関係
const int sp=300;
float KP = 10.0, d = 100.0; // 目標距離 100[mm]

void JJ7Controller(float y) {
  float u; // 制御量

  u = KP * (d - y); // 比例制御変数（制御信号）
  if (u > sp) u = sp;  // 設定速度を超過
  if (u < -sp) u = -sp;// 設定速度を超過
  Serial.println(u);
  velocityJJ7(0.0, -u);
}
