// Ex0505
// Nov. 11, 2019 by H.K.
//

#include "myVelocity.h"
#include "myFastLed.h"
#include "myDist.h"

void setup() {
  mySetup();
  myFastLedSetup();
  JJ7Axes();
  myDistSetup();
  
  while (digitalRead(SW_PIN)==HIGH);
  delay(100);
}

void loop() {
  int y = dist_measure00(0, 500);
  if (y != -1) {// 0[mm]から500[mm]までの距離測定
    Serial.println(y);
    JJ7Controller(y); // ロボットを負帰還比例制御
    delay(10);        // 信号により前後に動かせる
  }
}

// 制御関係
const int sp=200;
float KP = 0.002, d1 = 50.0, d2=150.0, d3=250.0;

void JJ7Controller(float y) {
  float u; // 制御量

  u = KP * (d1 - y)*(d2-y)*(d3-y); 
  if (u > sp) u = sp;
  if (u < -sp) u = -sp;
  Serial.println(u);
  velocityJJ7(0.0, -u);
}
