// Ex0506: JJ7 oscillates between d1 and d2
// Nov. 14, 2019 by H.K.
//

#include "myVelocity.h"
#include "myFastLed.h"
#include "myDist.h"

void setup() {
  mySetup();
  myFastLedSetup();
  JJ7Axes();
  myDistSetup();
  
  while (digitalRead(SW_PIN)==HIGH);
  delay(100);
}

float d = 100.0, d1=100.0, d2=300.0;

void loop() {
  int y = dist_measure00(0, 500);
  if (y != -1) {// 0[mm]から500[mm]までの距離測定
    Serial.println(y);
    JJ7Controller(y); // ロボットを負帰還比例制御
    delay(10);        // 信号により前後に動かせる
  }
  changeTarget(y);
}

void changeTarget(float y){
  float eps=3.0;
  
  if(fabs(d1-y)<eps){ 
    d=d2;
    delay(500);
  }// m1 |=> m2
  if(fabs(d2-y)<eps){ 
    d=d1;
    delay(500);
  }// m2 |=> m1
}

float KP = 20.0, sp=250.0;

void JJ7Controller(float y) {
  float u, u0=100.0; // 制御量

  u = KP * (d - y); // 比例制御変数（制御信号）
//  if(fabs(u)< u0) u=0.0;
  if (u > u0) u = sp;  // 設定速度を超過
  if (u < -u0) u = -sp;// 設定速度を超過
  Serial.println(u);
  velocityJJ7(0.0, -u);
}
